#include <stdio.h>

// **********************************************
class BaseA
{
public:
	int	i;
	virtual void	foo(){printf("%p:%s::foo()\n",this,"BaseA");}
	virtual ~BaseA(){}
};

class BaseB
{
public:
	int	i;
	virtual void	foo(){printf("%p:%s::foo()\n",this,"BaseB");}
	virtual ~BaseB(){}
};

class Derived: public BaseA, public BaseB 
{
public:
	void	foo(){printf("%p:%s::foo()\n",this,"Derived");}
};

// **********************************************
Derived		*d=0;
BaseA		*a=0;
BaseB       *b=0;
BaseB       *b2=0;

BaseB       *b3=0;
Derived		*d3=0;

Derived		*d4=0;

void	boo(BaseB* p)
{
	d4=static_cast<Derived*>(p);
	if(d4)d4->Derived::foo();	
}

// **********************************************
int		main()
{
	d=new Derived();
	a=d;
	b=d;
	b2=static_cast<BaseB*>(d);

	b3=new Derived();
	d3=static_cast<Derived*>(b3);

	d->foo();	
	a->BaseA::foo();	
	b->BaseB::foo();	
}
